<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="websiteId"
          :columns="columns"
          :datasource="datasource"
          :customRow="customRow"
          :need-page="false"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'websiteLogo'">
              <a-image :src="record.websiteLogo" :width="50" />
            </template>
            <template v-if="column.key === 'domain'">
              <a-button
                type="link"
                @click="openUrl(`${record.prefix}${record.domain}`)"
                >{{ record.domain }}</a-button
              >
            </template>
            <template v-if="column.key === 'type'">
              <a-tag v-if="record.type === 1" color="green">是</a-tag>
              <a-tag
                v-if="record.type === 0"
                @click="updateType(record)"
                class="cursor-pointer"
                >否</a-tag
              >
            </template>
            <template v-if="column.key === 'version'">
              <a-tag v-if="record.version === 10">免费版</a-tag>
              <a-tag v-if="record.version === 20">授权版</a-tag>
              <a-tag v-if="record.version === 30">永久授权</a-tag>
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 0" color="green">正常</a-tag>
              <a-tag v-if="record.status === 1" color="red">已过期</a-tag>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a @click="openUrl(`${record.prefix}${record.domain}`)">首页</a>
                <a-divider type="vertical" />
                <a @click="openUrl(record.adminUrl)">后台</a>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <WebsiteEdit v-model:visible="showEdit" :data="current" @done="reload" />
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import { toDateString } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import WebsiteEdit from './components/websiteEdit.vue';
  import {
    pageWebsite,
    removeWebsite,
    removeBatchWebsite,
    updateWebsite
  } from '@/api/cms/website';
  import type { Website, WebsiteParam } from '@/api/cms/website/model';
  import { openPreview, openUrl } from '@/utils/common';
  import { getSiteDomain } from '@/utils/domain';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<Website[]>([]);
  // 当前编辑数据
  const current = ref<Website | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);
  const domain = getSiteDomain();

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageWebsite({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: '网站名称',
      dataIndex: 'websiteName',
      key: 'websiteName',
      align: 'center'
    },
    {
      title: 'Logo',
      dataIndex: 'websiteLogo',
      key: 'websiteLogo',
      align: 'center'
    },
    {
      title: '主域名',
      dataIndex: 'domain',
      key: 'domain',
      align: 'center'
    },
    {
      title: '网站描述',
      dataIndex: 'comments',
      key: 'comments',
      align: 'center'
    },
    {
      title: '当前版本',
      dataIndex: 'version',
      key: 'version',
      align: 'center'
    },
    {
      title: '状态',
      dataIndex: 'status',
      key: 'status',
      align: 'center'
    },
    {
      title: '创建时间',
      dataIndex: 'createTime',
      key: 'createTime',
      align: 'center',
      sorter: true,
      ellipsis: true,
      customRender: ({ text }) => toDateString(text, 'yyyy-MM-dd')
    },
    {
      title: '操作',
      key: 'action',
      width: 120,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: WebsiteParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: Website) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  const updateType = (row: Website) => {
    updateWebsite(row).then((msg) => {
      message.success(msg);
      reload();
    });
  };

  /* 删除单个 */
  const remove = (row: Website) => {
    const hide = message.loading('请求中..', 0);
    removeWebsite(row.websiteId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchWebsite(selection.value.map((d) => d.websiteId))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: Website) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };
  query();
</script>

<script lang="ts">
  export default {
    name: 'Website'
  };
</script>

<style lang="less" scoped></style>
